﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Brains.Framework.Behaviors.PathFinding;
using Brains.Framework.Behaviors;

namespace AIRendering
{
    public class DrawableCyclicRoute : CyclicPathBehavior, IRender
    {

        public void Render(PrimitiveBatch batch)
        {
            if (CurrentSubBehavior > 0)
            {
                if (SubBehaviors[CurrentSubBehavior] is IRender)
                {
                    ((IRender)SubBehaviors[CurrentSubBehavior]).Render(batch);
                }

                ISubBehaviorHolder subs = (ISubBehaviorHolder)SubBehaviors[CurrentSubBehavior];
                if (subs != null)
                {
                    for (int i = 0; i < subs.SubBehaviors.Count; i++)
                    {
                        if (subs.SubBehaviors[i] is FollowPathBehavior)
                        {
                            DrawableBehaviorGoTo.DrawFollowPath(subs.SubBehaviors[i] as FollowPathBehavior,
                                batch);
                        }

                    }
                }
            }
        }
    }
}
