﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Serialization;

namespace Designer.Classes
{
    public class BehaviorNode
    {
        public string Name { get; set; }
        
        [XmlIgnore()]
        public Type Type { get; set; }
        
        private string _typeName="";
        public string TypeName
        {
            get 
            {
                if (Type == null || Type == typeof(System.Type)) 
                    return _typeName;
                else 
                    return Type.FullName;
            }
            
            set { _typeName = value; }
        }
        
        public List<Parameter> Parameters { get; set; }

        public List<BehaviorNode> SubBehaviors { get; set; }
        public BehaviorNode()
        {
            Parameters = new List<Parameter>();
            SubBehaviors = new List<BehaviorNode>();
        }



        internal void AddParameter(string name, string value)
        {
            Parameter p = new Parameter(name, value);
            Parameters.Add(p);
        }
    }
    public class Parameter
    {
        public string Name { get; set; }
        public string Value { get; set; }
        public Parameter()
        {
        }
        public Parameter(string name, string value)
        {
            Name = name;
            Value = value;
        }
    }
}
