﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Brains.Framework.Behaviors;
using Brains.Framework;
using Microsoft.Xna.Framework;

namespace Brains.Framework.Behaviors
{
    public class ConditionBehavior:IBehavior,IConditionBehavior
    {
        private Agent _owner;

        public ConditionBehavior()
        {
        }

        
        public Agent Owner
        {
            get { return _owner; }
        }

        public BehaviorState State{get;set;}

        public void SetOwner(Agent owner)
        {
            _owner = owner;
        }

        public virtual void Update(GameTime gameTime)
        {
            
        }

        public virtual void OnSuccess()
        {
            
        }

        public virtual void OnFailure()
        {
            
        }

        public virtual void Reset()
        {
            State = BehaviorState.Idle;
        }

        public bool ConditionCheck { get; set; }
    }
}
