﻿
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Brains.Framework.Designer
{
    /// <summary>
    /// Behavior Attribute exposes the behavior to the Designer
    /// </summary>
    [global::System.AttributeUsage(AttributeTargets.Class, Inherited = false, AllowMultiple = false)]
    public sealed class BehaviorAttribute : Attribute
    {
        readonly string _friendlyName;
        
        public BehaviorAttribute(string friendlyname)
        {
            this._friendlyName = friendlyname;
        }

        public string FriendlyName
        {
            get
            {
                return this._friendlyName;
            }
        }

    }

    /// <summary>
    /// Behavior Parameter Attribute exposes the behavior parameter to the Designer
    /// </summary>
    [global::System.AttributeUsage(AttributeTargets.Property,Inherited = false,AllowMultiple = false)]
    public sealed class BehaviorParameterAttribute : Attribute
    {
        readonly string _friendlyName;

        public BehaviorParameterAttribute(string friendlyname)
        {
            this._friendlyName = friendlyname;
        }

        public string FriendlyName
        {
            get
            {
                return this._friendlyName;
            }
        }

    }

}
