﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Xna.Framework;

namespace AIFramework.StateMachine
{
    public class StateMachine
    {
        public List<State> States { get; set; }
        public StateMachine()
        {
        }
        public T GetState<T>()
        {
            return States.OfType<T>().First();
        }

        public void AddState(State state)
        {
            States.Add(state);
        }

        
    }
    public interface IState
    {
        string Name { get; set; }
        void Enter();
        void Exit();
        void Update(GameTime gameTime);
        IState ChangeState(IState state);
    }
}
